// Pattern per il controllo di validita' dei campi
var no_num_pattern       = /[\d\x00-\x1F\!\"\#\$\%\&\(\)\*\\\:<=>?\[\]^`{\|}~\r\n\f\@]/;
var telephone_pattern    = /^[\d \-\/\+\.]+$/i;
var generic_pattern      = /[\x00-\x1F\!\"\#\$\%\&\(\)\*\\\:<=>?\[\]^`{\|}~\r\n\f\@]/;
var mail_pattern         = /^([\w-][\w-\.]*(?:\+[\w-\.]+)?)@([a-zA-Z0-9][\w-\.]*)\.([a-zA-Z]{2,20})$/;


function doSeasonTicketSubmit(data) {
  $('#formBasket #cmd').val('seasonTicket');
  $('#formBasket #data').val(data);
  $('#formBasket').submit();
}


function bloccaCarrello(alt) {
  ok = true;
  $('.invalid').hide();
  
  if ($('#cartCustomer').length)
    ok = verifica_customer() && ok;

  if ($('#checkRegolamento').length)
    ok = checkRegolamentoBasket() && ok;
  
  if ($('#formBasket #spedizione').length > 0 &&
      $('#formBasket #spedizione').val() == 1) {
    ok = verifica_anagrafica_sped() && ok;
    // aggiungo le alla query string le transazioni da spedire
    if (ok) AddTranSped();
  }

  if (!ok) {
    alert (frasi.carrello['completaAnagrafica']);
    return;
  }
  if (alt == 'amazonPay') $('#amazonclick').val(3);
  trackEvent('click', {event_action: 'click', event_category: 'Basket CONFIRM', event_label: 'CARRELLO' });

  $('#formBasket #cmd').val('bloccaCarrello');
  $('#formBasket').submit();
}



function delFromBasket() {
  if ($('.to-delete').length > 0 && $('.to-delete:checked').length == 0)
    return;
  var del = window.confirm(frasi.carrello['delFromBasket']);
  if (del) {
    $('#formBasket #cmd').val('cancellaCarrello');
    $('#formBasket').submit();
  }
}

function emptyBasket() {
  return window.confirm(frasi.carrello['emptyBasket']);
}

function altriAcquisti() {
  alert(frasi.carrello['altriAcquisti']);
  window.location = '/';
}


//Allinea i checkbox della stessa transazione sulla cancellazione dal carrello
function deleteAllInTran(obj, code) {
  checked = obj.checked;

  del = document.getElementsByName('del[]');
  exp = new RegExp('^' + code +',.+');

  for (var i = 0 ; i < del.length ; ++i) {
    if (del[i].type != 'checkbox') continue;
    if (exp.test(del[i].value))    del[i].checked = checked;
  }
}

function checkFidelityCode() {
  for (var i = 0 ; i < $('#nTicket').val(); ++i) {
    if ($('#bscode_' + i).length && $('#bscode_' + i).val().length==0) {
      alert(frasi.tabellaPrezzi['checkFidelityCode']);
      return false;
   }
  }
  $('#fidelityCardTable').submit();
}



function verifica_customer() {
  // Pattern per il controllo di validita' dei campi
  error = false;
  
  $('.customer_error').hide();
  if ($('#customer_nome').val().length == 0) {
    error = true;
    $('#customer_nome_error').html(frasi.personalDetails['required']).show();
  }
  else if ($('#customer_nome').val().length < 2 || no_num_pattern.test($('#customer_nome').val())) {
    error = true;
    $('#customer_nome_error').html(frasi.personalDetails['no_num']).show();
  }
  
  if ($('#customer_cognome').val().length == 0) {
    error = true;
    $('#customer_cognome_error').html(frasi.personalDetails['required']).show();
  }
  else if ($('#customer_cognome').val().length < 2 || no_num_pattern.test($('#customer_cognome').val())) {
    error = true;
    $('#customer_cognome_error').html(frasi.personalDetails['no_num']).show();
  }
  
  if ($('#customer_email').val().length == 0) {
    error = true;
    $('#customer_email_error').html(frasi.personalDetails['required']).show();
  }
  else if ($('#customer_email').val().match(mail_pattern)==null || $('#customer_email').val().length <= 3 || $('#customer_email').val().length > 70) {
    error = true;
    $('#customer_email_error').html(frasi.personalDetails['email']).show();
  }

  if ($('#customer_company').length && $('#customer_company').val().length == 0) {
    error = true;
    $('#customer_company_error').html(frasi.personalDetails['required']).show();
  }

  if ($('#customer_cf').length  && $('#customer_cf').val().length<1 ) {
    error = true;
    $('#customer_cf_error').html(frasi.personalDetails['required']).show();
  }
  
  if ($('#guest').length) {
    $('.consent').each( function() { 
      if ($(this).hasClass('required') && 
          !$('[name="'+$(this).attr('name')+'"]:checked').length &&
           $('[name="'+$(this).attr('name')+'"]:checked').val() != 1) {
    	$('[id="'+$(this).attr('name')+'_msg"]').html(frasi.carrello['required']).show();
        error= true;
      }
    });
  }
  
  if (typeof verifica_customer_addcontrol === "function") {
    if (!verifica_customer_addcontrol()) 
      error = true;
  }

  
  if (error) return false;
  return true;
}


$(document).ready(function(){
  $('.to-delete').click(function () {
    t=0;
    $('.to-delete').each(function (i) {
      if ($(this).is(':checked'))
        t=1;
    })
    if (t==0)
     $('.btn-delete').attr('disabled', true);
    else
      $('.btn-delete').attr('disabled', false);
  });
});


