/**
 * classe che gestisce la visualizzazione delle informazioni sul posto
 */
var Info = new function() {
	/*
	this.automaticChoiceLabel = 'ATTENZIONE: Questo posto pu&ograve; essere assegnato solo tramite scelta automatica';
	this.maxseatsLabel = 'ATTENZIONE: RAGGIUNTO IL MASSIMO NUMERO DI POSTI SELEZIONABILI';
	this.maxseatszoneLabel = 'ATTENZIONE: RAGGIUNTO IL MASSIMO NUMERO DI POSTI SELEZIONABILI SULLA ZONA';
	this.missingSeatsLabel = 'ATTENZIONE: per utilizzare questa riduzione &egrave; necessario aver selezionato almeno #NUM# posti';
	*/
	this.currentSeat = null;
	
	this.init = function() {
		Selection.addListener(this);
	}
	
	this.changed = function(event) {
		switch (event.action) {
			case 'maxseats':
				this.hide();
				this.show(frasi.mappa['lbl-postiEsauriti'], true);
				break;
			case 'maxseatszone':
				this.hide();
				this.show(frasi.mappa['lbl-zonaEsaurita'], true);
				break;
			case 'select':				
			case 'recall':
				// evento di mouse sul seat
				// evento di recall dal carrello
				if (event.target.status == -1) {
					this.show(frasi.mappa['lbl-sceltaAutomatica']);
				} else {
					this.paint(event.target);
				}
				break;
			case 'deselect':
			case 'remove':
				// evento di mouse out dal seat o bookmark
				// evento di remove dal carrello
				this.hide();
				break;
			case 'sector':
				// evento di mousein sul bookmark
				this.sector(event.target);
				break;
			case 'add':
				// seat aggiunto al carrello
				this.paint(event.target);
				break;
			case 'missingseatsforreduction':
				this.hide();
				if (event.target>0) {
					this.show(frasi.mappa['lbl-minimoRiduzione'].call(this, event.target), true);
				}
				break;
		}
	}
	
	/**
	 * funzione sostitutiva a paintLabel
	 * inserisce i dettagli del posto nella legend
	 */
	this.paint = function(seat) {

		if (seat === undefined) { seat = null; }
		
		if (seat != null) {
			Info.currentseat = seat;
		}
		
		if (seat == null) {
			if (Info.currentseat != null) {
				seat = Info.currentseat;			
			} else {
				return;
			}
		}
		
		// imposto il prezzo prendendo la prima riduzione 
		// TODO: verificare se è da mettere quella che si chiama Intero
		var price =  Seats.zones[seat.zone].getDefaultPrice().getAmount();
		
		
		// elimino il precedente seat-legend
		this.hide();
		
		var text = document.createElement('div');
		text.id = 'seat-legend';
		text.style = 'padding:0.2rem 1rem;';
		
		var tspan = document.createElement('div');
		tspan.innerHTML = Seats.zones[seat.zone].description;
		tspan.style = 'display:inline-block;font-weight:bold;vertical-align:top;';
		tspan.className = 'legend-item';
		text.appendChild(tspan);
		
		tspan = document.createElement('div');
		tspan.innerHTML = seat.description;
		tspan.setAttribute('title',seat.description);
		tspan.className = 'legend-item';
		//tspan.style = 'display:inline-block;text-overflow:ellipsis;overflow:hidden;width:40%;white-space:nowrap;margin-top:0.3rem;';
		text.appendChild(tspan);
		
		tspan = document.createElement('br');
		tspan.className = 'hide-wide';
		text.appendChild(tspan);
		
		
		tspan = document.createElement('div');
		tspan.style = 'float:right;display:inline;position:absolute;bottom:0.5rem;right:0.4rem;';
		tspan.innerHTML = '&euro; ' + price;
		text.appendChild(tspan);
		
		tspan = document.createElement('div');
		tspan.innerHTML = Seats.zones[seat.zone].getDefaultPrice().label;
		tspan.style = 'display:inline;float:right;margin-right:2rem; margin-left:2rem;position:absolute;bottom:0.5rem;right:5rem;';
		text.appendChild(tspan);
		
		
		$('#seat-info').prepend(text);
		
	
	}
	
	/**
	 * mostra le informazioni del settore
	 */
	this.sector = function(poly) {
		this.hide();
		
		var text = document.createElement('div');
		text.id = 'seat-legend';
		text.style = 'padding:0.2rem 1rem;';
		
		var tspan = document.createElement('div');
		tspan.innerHTML = Seats.bookmarks[poly].name;
		tspan.style = 'display:inline-block;font-weight:bold;margin-right:2rem;vertical-align:top;max-width:45%;';
		text.appendChild(tspan);
		
		tspan = document.createElement('div');
		tspan.innerHTML = frasi.mappa['lbl-postiDisponibili'] + Seats.bookmarks[poly].available;
		tspan.style = 'display:inline-block;text-overflow:ellipsis;overflow:hidden;width:50%;white-space:nowrap;';
		text.appendChild(tspan);
		
		tspan = document.createElement('br');
		tspan.className = 'hide-wide';
		text.appendChild(tspan);
		
		if (Seats.bookmarks[poly].available > 0) {
			tspan = document.createElement('div');
			tspan.style = 'float:right; font-weight:bold; display:inline;';
			tspan.innerHTML = '&euro; ' + Seats.bookmarks[poly].getStartingPrice();
			text.appendChild(tspan);
			
			tspan = document.createElement('div');
			tspan.innerHTML = frasi.mappa['lbl-prezzoIniziale'];
			tspan.style = 'display:inline;margin-right:0rem;vertical-align:top;';
			text.appendChild(tspan);
		}
		
		$('#seat-info').prepend(text);
	}
	
	/**
	 * mostra un messaggio generico
	 */
	this.show = function(content, warning) {
		if (warning === undefined) {
			warning = false;
		}
		var text = document.createElement('div');
		text.id = 'seat-legend';
		text.innerHTML = content;
		text.style = 'padding:1rem;';	
		// cambio colore sul warning
		if (warning) {
			text.style = 'padding:0.25rem 1rem;color:#E00;font-size:1.25rem;';
		}
		
		$('#seat-info').prepend(text);
		
	}
	
	/**
	 * nasconde il messaggio 
	 */
	this.hide = function() {
		$('#seat-info').find('#seat-legend').remove();
	}
}


