/**
 *  classe per disegnare il thumb del posto a sedere sulla mappa
 */
var SeatThumb = new function() {
	this.tag = '';
	this.handler = 'map/getSeatPicture.php';
	this.root = 'thea_seat_images/';
	
	this.init = function(param) {
		// se Ã¨ abilitata la visualizzazione delle immagini mi registro alla mappa
		if (param != '') {
			this.tag = param;
			Selection.addListener(this);			
		}
	}
	 
	this.changed = function(event) {			
		
		switch (event.action) {			
			case 'select':
				// mousein sul posto
				if (event.target.status == 0) {
					this.show(event.target.id, MapLoader.roomId);
				} else {
					this.hide();
				}
			case 'recall':
				// selezionato sul carrello
				this.hide();
				setTimeout(function() {
					if (event.target.status == 0) {
						SeatThumb.show(event.target.id, MapLoader.roomId);
					}
				}, 1000);
				break;
			case 'deselect':
			case 'remove':
				// mouseout sul posto
				// rimosso dalla selezione
				this.hide();			
				break;
		}
	}
	
	/**
	 * mostra il riquadro con l'immagine del posto
	 */
	this.show = function(seat, room) {
		// faccio una chiamata allo script che mi restituisce il nome del file dell'immagine
		$.ajax({
			url: SeatThumb.handler,
			method: 'POST',
			data: { room: room, seat: seat }
		}).done(function(ret) {
			if (ret != '') {
				// costruisco il nome dell'immagine
				var path = SeatThumb.root + room + '/' + ret + '.jpg';
				
				// creo un layer 
				var rect = document.createElement('div');
				rect.className = 'seat-layer';
				rect.style = 'top:20px; right:32px;';
				
				var pict = document.createElement('img');
				pict.src = path;
				pict.style = 'max-width:200px;';
				rect.appendChild(pict);
				$('#map-container').append(rect);
				
				//console.log('displaying '+ ret + ' for seat ' + seat + ' on ' + room);
			} else {
				SeatThumb.hide();
			}
		});
	}
	
	/**
	 * nasconde il riquadro con l'immagine del posto
	 */
	this.hide = function() {
		$(".seat-layer").remove();
	}
	
}
