
function setOption (text, value, toSelect) {
  return $('<option>', {text: text, value : value}).prop('selected', toSelect);
}


function chargeCountry () {
  $.each(countryHash, function(value, text) {
    $('#ft_nazione').append( setOption (text, value, ft_nazione_db == value));
  });
}

function chargeRegion () {
  $.each(regionHash, function(value, text) {
    $('#ft_provincia').append( setOption (text, value, ft_provincia_db == value));
  });
}


function fillComuni (event, provincia) {
  if (typeof provincia == 'undefined')
    var provincia = $(this).attr('id');
  
  var p = $('#'+provincia).val();
  if (p == '') com = {};
  else         com = comuniHash[p];

  $('#ft_citta').empty();
   
  if (Object.keys(com).length != 1)
    $('#ft_citta').append($('<option>', { value : '', text: '----' }));
  
  if ($.isEmptyObject(com)) {
    fillCAP ('ft_citta');
    return;
  }

  $.each(com, function(key, value) {
    $('#ft_citta').append( setOption (value, key+";"+value, (eval('ft_citta_db').toUpperCase() == value.toUpperCase())));
  });
  fillCAP ('ft_citta');
}


function changeComuniCAP () {
  fillCAP ($(this).attr('id'));
}
  

function fillCAP () {
  if ($('#ft_citta option').length == 0)
    return;
  var c = $('#ft_citta option:selected').val().split(';');
  var idc = c[0];
  if (idc == '') CAPC = new Array();
  else           CAPC = capHash[idc];

  $('#ft_cap').empty();
  
  if (typeof CAPC == "undefined")
    return;
  if (CAPC.length != 1)
        $('#ft_cap').append($('<option>', { value : '', text: '----' }));
  if ($.isEmptyObject(CAPC)) return;
    
  $.each(CAPC, function(key, value) {
      $('#ft_cap').append( setOption (value, value, eval('ft_cap_db') == value));
    });
}

function changeType(type) {
  if (type == "m") {
    $('.ft_p').show();
    $('.ft_a').hide();
  }
  else {
    $('.ft_p').hide();
    $('.ft_a').show();
  }
  $('.ft').show();
}


function switchCountryLayoutTo() {
  if ($('#ft_nazione').val() == 'it') {
    $('#ft_provincia, #ft_citta, #ft_cap').removeAttr("disabled");
    $('#ft_provincia_e, #ft_citta_e, #ft_cap_e').attr("disabled", true);
    if (ft_nazione_db != 'it') $('#ft_provincia, #ft_citta, #ft_cap, #ft_indirizzo').val('');
    $('.italia').show();
    $('.estero').hide();
    $('#ft_piva_label').addClass('RequiredField');
  }
  else {
    $('#ft_provincia, #ft_citta, #ft_cap').attr("disabled", true);
    $('#ft_provincia_e, #ft_citta_e, #ft_cap_e').removeAttr("disabled");
    if (ft_nazione_db == 'it') $('#ft_provincia_e, #ft_citta_e, #ft_cap_e, #ft_indirizzo').val('');
    $('.estero').show();
    $('.italia').hide();
    $('#ft_piva_label').removeClass('RequiredField');
  }
}

function switchCF() {
  if ($('#no_cf').is(':checked')) {
    $('#ft_codfisc').attr("disabled", true);
    $('#ft_codfisc_e').removeAttr("disabled");
    $('.ft_cf_i').hide();
    $('.ft_cf_e').show();
  }
  else {
    $('#ft_codfisc_e').attr("disabled", true);
    $('#ft_codfisc').removeAttr("disabled")
    $('.ft_cf_e').hide();
    $('.ft_cf_i').show();
  }
}

$(document).ready(function(){
  chargeCountry();
  chargeRegion();
  if ($('#ft_citta').length) {
    fillComuni (null,'ft_provincia');
  }

  $('#ft_nazione').change (switchCountryLayoutTo);
  $('#ft_provincia').change (fillComuni);
  $('#ft_citta').change (changeComuniCAP);
  $('#no_cf').change(switchCF);

  changeType(startType);
  switchCountryLayoutTo ();
  switchCF ();
  
});



$(document).ready(function(){


  //VALIDATE
  //tolgo gli spazi bianchi
  $('#ft_citta, #ft_citta_e').blur(function () {
    $(this).val($('<div/>').html($(this).val()).text());
  });
  $("#formInvoice").validate({
    //debug: true,
    rules: {
      //DATI FATTURA
      invoice_type: {required: true},
      ft_ragsoc:    {required: function() {return $('#invoice_type_a').is(':checked');},
                     rangelength: [2, 25],
                     NOTpattern: NOTpattern_strNum},
      ft_nome:      {required: function() {return $('#invoice_type_pf').is(':checked');},
                     rangelength: [2, 25],
                     NOTpattern: NOTpattern_str},
      ft_cognome:   {required: function() {return $('#invoice_type_pf').is(':checked');},
                     rangelength: [2, 25],
                     NOTpattern: NOTpattern_str},
      //indirizzo
      ft_nazione:   {required: true},
      ft_provincia: {required:    {depends: function() {return $('#ft_nazione').val() == 'it'; }},
                     rangelength: {depends: function() {return $('#ft_nazione').val() != 'it';}, param:[2, 25]},
                     NOTpattern: NOTpattern_str},
      ft_citta:     {required: true,
                     rangelength: {depends: function() {return $('#ft_nazione').val() != 'it';}, param:[2, 35]},
                     NOTpattern:  {depends: function() {return $('#ft_nazione').val() != 'it';}, param: NOTpattern_str}},
      ft_cap:       {required: true,
                     rangelength: {depends: function() {return $('#ft_nazione').val() != 'it';}, param:[3, 11]},
                     NOTpattern: NOTpattern_strNum},
      ft_indirizzo: {required: true,
                     rangelength: [2, 70],
                     NOTpattern: NOTpattern_strNum},
                     
                     
      ft_codfisc:   {required: {depends: true},
                     rangelength: {depends: function() {return $('#invoice_type_pf').is(':checked') && $('#no_cf').is(':checked')}, param: [2, 20]},
                     NOTpattern:  {depends: function() {return $('#invoice_type_pf').is(':checked') && $('#no_cf').is(':checked')}, param: NOTpattern_strNum },
                     codiceFiscale: {depends: function () {return $('#invoice_type_pf').is(':checked') && !$('#no_cf').is(':checked'); }} },
                     
      ft_piva:      {required: {depends: true},
                     rangelength: {depends: function() {return $('#invoice_type_a').is(':checked') && $('#ft_nazione').val() != 'it'}, param: [2, 20]},
                     NOTpattern:  {depends: function() {return $('#invoice_type_a').is(':checked') && $('#ft_nazione').val() != 'it'}, param: NOTpattern_strNum },
                     partita_iva: {depends: function () {return $('#invoice_type_a').is(':checked') && $('#ft_nazione').val() == 'it'; }}}
        
    }
  });

});


/* ************************ Codice Fiscale ********************************* */
/*
$(document).ready(function(){
	var cfType = '';
	var bl_nascita_testo = '';
	
	$('#cfModal').on('show.bs.modal', function (event) {
		var button = $(event.relatedTarget) // Button that triggered the modal
		cfType = button.data('kind') 		//"a" = Anagrafica | "f" = Fatturazione
	  
		if (cfType == 'a') {
			$('#bl_nome').val($('#nome').val());
			$('#bl_cognome').val($('#cognome').val());
			$('#bl_sesso').val($('#sesso').val());
			$('#bl_data_nascita').val($('#data_nascita').val());
		} else {
			$('#bl_nome').val($('#ft_nome').val());
			$('#bl_cognome').val($('#ft_cognome').val());
			$('#bl_sesso').val('');
			$('#bl_data_nascita').val('');
		}
		$('#bl_nascita').val('');
		$('#bl_nascita_codice').val('');
	});
	
	$('#cfModal #cfCalcola').click(function () {
		if (!controllaDatiCodiceFiscale ($('#bl_nome').val(), $('#bl_cognome').val(), $('#bl_sesso').val(),
										 $('#bl_data_nascita').val(), $('#bl_nascita').val(), $('#bl_nascita_codice').val()
		)) return false;
		var cf = calcolaCodiceFiscale($('#bl_nome').val(), $('#bl_cognome').val(), $('#bl_sesso').val(),
									  $('#bl_data_nascita').val(), $('#bl_nascita_codice').val());
		
		if (cfType == 'a') {
			$('#fiscale').val(cf);
			$('#nome').val($('#bl_nome').val());
			$('#cognome').val($('#bl_cognome').val());
			$('#sesso').val($('#bl_sesso').val());
			$('#data_nascita').val($('#bl_data_nascita').val());
			$('#data_nascita').change();
		} else {
			$('#ft_fiscale').val(cf);
			$('#ft_nome').val($('#bl_nome').val());
			$('#ft_cognome').val($('#bl_cognome').val());
		}
		
		$('#cfModal').modal('hide');
	});
	
	$("#bl_nascita").change (function() { if ($(this).val() != bl_nascita_testo ) $('#bl_nascita_codice').val('');  });
	$("#bl_nascita").autocomplete ({
		source: function (request, response) {
			$.ajax( {
				url:"/inc/retriever.php?callback=?",
				dataType: 'json',
				data: { limit: 20, comune_cf: request.term},
				success: function (data) {
					var suggestions = [];
					$.each(data, function(i, val){ suggestions.push(val); });
					response(suggestions);
				}
			} );
		},
		minLength: 2,
		select: function( event, ui ) {
			event.preventDefault();
			bl_nascita_testo = ui.item.label;
			$('#bl_nascita_codice').val(ui.item.value);
			$('#bl_nascita').val(ui.item.label);
		},
		focus:  function() {
			if (this.value != bl_nascita_testo ) $('#bl_nascita_codice').val('');
		}
	});
});

function controllaDatiCodiceFiscale (nome, cognome, sesso, data, luogo, luogo_code) {
  var errMsg = '';
  var ckdate = false;
  var ok = true;
  
  if (!nome)             errMsg  = frasi.anagrafica['nome']+'\n';
  if (!cognome)          errMsg += frasi.anagrafica['cognome']+'\n';
  if (!sesso)            errMsg += frasi.anagrafica['sesso']+'\n';
  if (!data)             errMsg += frasi.anagrafica['data_nascita']+'\n';
  else ckdate = true;
  
  // non ho digitato nulla oppure ho digitato e non trovato nulla
  if (!luogo) errMsg += frasi.anagrafica['luogo_nascita']+'\n';
  else if (!luogo_code) {
    luogo.focus();
    ok = false;
  }
  
  if (errMsg) errMsg = frasi.anagrafica['emptyErrorChkCF']+'\n'+errMsg;
   
  if (ckdate && !chkDate (data))
    errMsg += frasi.anagrafica['errorChkBDate']+'\n';

  if (errMsg) {
    alert (errMsg);
    ok = false;
  }

  return ok;
}


//Controllo data di nascita
function chkDate (date) {
  var matches = /^(\d{2})[-\/](\d{2})[-\/](\d{4})$/.exec(date);
  if (matches == null) return false;
  
  var d = matches[1];
  var m = matches[2] - 1;
  var y = matches[3];
  var composedDate = new Date(y, m, d, 12, 0, 0);
  
  return composedDate.getDate() == d &&
         composedDate.getMonth() == m &&
         composedDate.getFullYear() == y;
}

*/


function calcolaCodiceFiscale (nome, cognome, sesso, data, luogo_code) {
  var vocali = /[AEIOU\s]/g ;
  var notVocali = /[^AEIOU]/g ;
  //cognome
  var consCognome = cognome.toUpperCase().replace(vocali,'');
  var vocCognome = cognome.toUpperCase().replace(notVocali,'');
  var codCognome = (consCognome+vocCognome+"XXX").substring(0,3);
  //nome
  var consNome = nome.toUpperCase().replace(vocali,'');
  if (consNome.length>=4) { //voglio 134
    var re = /^(.)(.)(.)(.).*/g;
    consNome = consNome.replace (re, "$1$3$4");
  }
  var vocNome = nome.toUpperCase().replace(notVocali,'');
  var codNome = (consNome+vocNome+"XXX").substring(0,3);
  //Data di nascita + luogo di nascita
  var matches = /^(\d{2})[-\/](\d{2})[-\/](\d{4})$/.exec(data);
  var dd = matches[1];
  var mm = matches[2] - 1;
  var yy = matches[3];

  var anno = yy.substring(2,4);
  var mese = 'ABCDEHLMPRST'.charAt(eval(mm));
  var gg = (sesso == 'F')? eval(dd)+40 : eval(dd);
  gg = (gg<10)? '0'+gg : gg;
  var cf = codCognome + codNome + anno + mese + gg + luogo_code;
  var controllo = calcolaCodiceDiControlloCF (cf);
  cf = cf + controllo;
  return cf;
}

//calcolo del codice di controllo del codice fiscale
function calcolaCodiceDiControlloCF (cf) {
  set1 = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  set2 = "ABCDEFGHIJABCDEFGHIJKLMNOPQRSTUVWXYZ";
  setpari = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  setdisp = "BAKPLCQDREVOSFTGUHMINJWZYX";
  var s = 0;
  for( var i = 1; i <= 13; i += 2 )
    s += setpari.indexOf( set2.charAt( set1.indexOf( cf.charAt(i) )));
  for( i = 0; i <= 14; i += 2 )
    s += setdisp.indexOf( set2.charAt( set1.indexOf( cf.charAt(i) )));
    
  var c = String.fromCharCode (s%26+'A'.charCodeAt(0));
  return c;
}

