var useScript = '';
// con questa variabile setto l'operatore, se serve, dalla risorsa
var operatorName = 'vivaticket';

$(document).ready(function(){
  //--- Per tutti ---
  //Date passate (range da -120 a oggi)
  var datepickerConfig= {
      changeMonth: true, changeYear: true, yearRange: "-120:+0",
      autoclose: true,  buttonImage: hostServerImage+"wms_images/calendario.jpg", buttonImageOnly: true
  };
  //Date Future (range 30 anni: 15 prima 15 dopo)
  var showDatepickerFuture= {
      changeMonth: true, changeYear: true, yearRange: "-15:+15",
      autoclose: true,  buttonImage: hostServerImage+"wms_images/calendario.jpg", buttonImageOnly: true
  };

  //Date Future (range 15 anni: -1 prima 15 dopo)
  var showDatepickerOnlyFuture= {
      changeMonth: true, changeYear: true, yearRange: "-1:+15",
      autoclose: true,  buttonImage: hostServerImage+"wms_images/calendario.jpg", buttonImageOnly: true
  };

  $(".showDatepicker").datepicker(datepickerConfig);
  $(".showDatepickerFuture").datepicker(showDatepickerFuture);
  $(".showDatepickerOnlyFuture").datepicker(showDatepickerOnlyFuture);
  $('.tohide').hide();
  
  switch (useScript) {
    //-------------------------- SCELTA MANUALE -----------------------------
    case 'SHOWTabPrezziManual':
      SHOW.sceltaManuale.impostaEventiMappa();
    break;
    
    //-------------------------- TABELLA PREZZI BESTSEAT --------------------
    case 'SHOWTabPrezziBS':
      SHOW.tabellaPrezzi.impostaEventi();
      SHOW.tabellaPrezzi.impostaEventiMappa ();
    break;
    
    //-------------------------- CAMBIO NOMINATIVO --------------------------
    case 'CTUEvent':
      SHOW.changeUserTicket.impostaSceltaTipo();
      break;
    case 'CTUAnagrafica':
      SHOW.changeUserTicket.impostaEventi();
      break;
    
    //-------------------------- TESSERA DEL TIFOSO -------------------------
    case 'TdtSelection':
    case 'TDTSelection':
      SHOW.emissioneTdT.impostaEventiSelezioneTdt();
      break;
    case 'TDTUser':
      SHOW.emissioneTdT.impostaFoto();
      //il break non c'e' appositamente
    case 'TDTUserWithoutPhoto':
      SHOW.emissioneTdT.impostaEventi();
      SHOW.emissioneTdT.impostaSpedizione();
      break;
    case 'TDTUserSummary':
      SHOW.emissioneTdT.caricaFoto();
      break;
    case 'TDTReplacementSummary':
      SHOW.emissioneTdT.impostaSpedizione();
      break;
    case 'TDTPhoto':
      SHOW.emissioneTdT.impostaFoto();
      break;
       
    //-------------------------- SET ANAGRAFICHE ----------------------------
    case 'SetAnagrafiche':
    default:
      SHOW.SetAnagrafiche.impostaEventi ();
      SHOW.SetAnagrafiche.impostaDatiAnagraficheErrate ();
      SHOW.SetAnagrafiche.impostaDatiRiduzioni ();
      break;
  }
  
});

//-------------------------- MAPPA - Parametri comuni tra bestseat e scelta manuale -----------------------------
staticAreaOption = {
    fillOpacity: 0.5,
    mapKey: 'data-key',
    staticState: true
};
rebindOption = {
    fillOpacity: 0.5,
    mapKey: 'data-key',
    isSelectable: false,
    highlight:false,
    singleSelect: true,
    render_highlight:{fillColor: 'd6eaff'},
    render_select:{fillColor: 'd6eaff', stroke: true, strokeColor: 'ff0000', strokeWidth: 2},
    showToolTip: true, toolTipClose: ["area-mouseout"],
    onMouseover: function (data) {
      if ($('.mapster_tooltip').length == 0) {
        $('#mappaEvento img').mapster('tooltip',this,frasi.tabellaPrezzi['noSeat']);
      }
    }
};


//Imposto il Namespace per SHOW e funzioni comuni
var SHOW = {
    
    /**
     * Funzioni accessorie per caricare Nazioni, Province e Comuni
     */
    //Carica i dati passati e li mette nella select indicata
    chargeData: function (_data, field, selectedValue) {
      $.each(_data, function(key, value) {
        var sel = selectedValue == key;
        $(field).append($('<option>', { value : key, text: value }));
      });
      $(field).val(selectedValue);
    },
    
    changeEstero: function (nazione, provincia, comune, reset) {
      if (nazione.is(':visible')) {
        var parent = nazione.parents('fieldset');
        if (parent.length == 0) parent = nazione.parents('form');
        if (nazione.val()=='') {
          parent.find('.soloItalia').hide();
          parent.find('.soloEstero').hide();
          parent.find('.soloItalia input, .soloItalia select').prop('disabled', true);
          parent.find('.soloEstero input, .soloEstero select').prop('disabled', true);
        }
        else if (nazione.val()=='ITA') {
          //Visualizzo l'italia e ne faccio usare i campi
          parent.find('.soloItalia').show();
          parent.find('.soloItalia input, .soloItalia select').prop('disabled', false);
          //Nascondo l'estero e rendo i campi non usabili
          parent.find('.soloEstero').hide();
          parent.find('.soloEstero input, .soloEstero select').prop('disabled', true);
        }
        else {
          //Nascondo l'italia e rendo i campi non usabili
          parent.find('.soloItalia').hide();
          parent.find('.soloItalia input, .soloItalia select').prop('disabled', true);
          //Visualizzo l'estero e ne faccio usare i campi
          parent.find('.soloEstero').show();
          parent.find('.soloEstero input, .soloEstero select').prop('disabled', false);
        }
        if (reset != false) {
          //Quando cambio nazione nascita devo resettare tutto
          parent.find('.soloItalia '+provincia).val('');
          parent.find('.soloItalia '+comune).empty();
          parent.find('.soloItalia input, .soloEstero input').val('');
        }
      }
    },
    
    changeComuni: function (provincia, setComune, field) {
      if (provincia.val() == '') return;
      //Se non ho la provincia non serve
      var url = "/inc/show_retriever.php?nome_provincia="+provincia.val();
      var parent = provincia.parents('fieldset');
      if (parent.length == 0) parent = provincia.parents('form');

      parent.find('.stillWait').html('<img alt="" src="'+hostServerImage+'wms_images/icons/spinner.gif">');
      $.getJSON(url, function(comuniHash) { SHOW.fillComuni ( provincia, comuniHash, setComune, field); });
    },


    fillComuni: function (provincia, comuniHash, setComune, field) {
      var parent = provincia.parents('fieldset');
      if (parent.length == 0) parent = provincia.parents('form');
      
      var campo = parent.find('.soloItalia '+field);
      campo.empty();

      if (comuniHash !== null)  {
          $.each(comuniHash, function(key, value) {
          var sel = setComune == value;
          campo.append($('<option>', { value : value, text: value}));
        });
        campo.val(setComune);
      }
      parent.find('.stillWait').html('');
    },
    
    //Metto assieme il tutto
    changeAddressData: function (dati, selectNazione, selectProvincia, selectComune) {
      //Carico i dati della nazione, regione e comune
      SHOW.chargeData(dati.countryHash, selectNazione, $(selectNazione).attr('data-selected')? $(selectNazione).attr('data-selected'):'ITA');
      SHOW.chargeData(dati.regionHash,  selectProvincia, $(selectProvincia).attr('data-selected'));
      SHOW.changeComuni($(selectProvincia), $(selectComune).attr('data-selected'), selectComune);
      //Faccio i visualizzare i campi corretti tra estero e non
      //NB: non faccio il reset dei campi
      SHOW.changeEstero($(selectNazione), selectProvincia, selectComune, false);

      //Imposto onchange sulla nazione
      $(selectNazione).change (function () {
        SHOW.changeEstero($(this), selectProvincia, selectComune);
      });
      //Imposto l'onchange sulla provincia
      $(selectProvincia).change (function () { SHOW.changeComuni($(this), null , selectComune); });
      
    }

};

//-------------------------- TABELLA PREZZI BESTSEAT -----------------------------
SHOW.tabellaPrezzi = {
   //imposta gli eventi sulla tabella prezzi
   impostaEventi: function () {
 	   
     // ----------------- SENZA MAPPA -----------------------
     //apro e chiudo il tipoPosto
     $('#tablePrice .tipoPosto').click( function () {
       //Reset
       $('#tablePrice tr.settore, #tablePrice tr.sceltaposti').hide();
       $('#tablePrice .arrow').removeClass('downArrow').addClass('rightArrow');
       
       //ed ora apro
       id = $(this).attr('data-id');
       $('#arrow_'+id).removeClass('rightArrow').addClass('downArrow');
       $('#tablePrice tr.settore[data-tipoPosto=\''+id+'\'],#tablePrice tr.sceltaposti[data-tipoPosto=\''+id+'\']').show();
     });
     // -----------------  MAPPA -----------------------
     $('map').click(SHOW.tabellaPrezzi.controlloLogin);
     // ----------------- TUTTI -----------------------
     $('input[type=radio][name=sector]').change (SHOW.tabellaPrezzi.controlloLogin);
     
     //CHECK SUBMIT
     $('#tablePriceSubmit #acquistaShow').click (function (e) {
       sector = $('input[name=sector]:checked').val();
       if (sector == undefined) {
         $('#nTickets').val(0);
         alert (frasi.tabellaPrezzi['zonaSel']);
         e.preventDefault();
         return false;
       }
       data = sector.split('-');
       //Se esiste il campo non ho la mappa su cui scegliere ma la lista dei settori
       if ($('#nTickets_'+data[0]).length > 0) {
         $('#nTickets').val($('#nTickets_'+data[0]).val());
       }
       if ($('input[name=pua_'+data[0]+']').length > 0) {
         $('#pua').val($('input[name=pua_'+data[0]+']:checked').val());
       }
       if ($('#nTickets').val() == 0) {
         alert (frasi.tabellaPrezzi['nTickets']);
         e.preventDefault();
         return false;
       }
       
       if ($('input[type=radio][name=pua]:enabled, input[type=radio][name=pua_'+data[0]+']:enabled').length > 0 &&
           $('input[type=radio][name=pua]:checked, input[type=radio][name=pua_'+data[0]+']:checked').length == 0) {
         alert (frasi.tabellaPrezzi['scegliPua']);
         e.preventDefault();
         return false;
       }

       //Se esiste posso scegliere l'opzione porta un amico
       if ($('input[name=pua]').length > 0) {
         var namici = parseInt($('#tablePrice tr.Prezzi[data-id='+data[0]+']').attr('data-pua'));
         if ($('input[type=radio][name=pua]:checked, input[type=hidden][name=pua]').val() == 1 &&
             $('#nTickets').val() > (namici+1)) {
           alert (frasi.show['nfriend'].call( this, (namici+1) )); 
           e.preventDefault();
           return false;
         }
       }
       return true;
     });
   },
   controlloLogin: function (){
     if ($('.btnAccediRegistrati, #btnAccediRegistrati').length >0 ) {
       alert (frasi.tabellaPrezzi['accediRegistrati']);
     }
     if ($('.btnCompleta, #btnCompleta').length >0) {
       alert (frasi.tabellaPrezzi['completaAnagrafica']);
     }
   },

   // ----------------- MAPPA -----------------------
   impostaEventiMappa: function () {

     if ($('map').length == 0) return;

 	//Ilumino la mappa al mouseover
     staticArea = new Array();  //Per illuminare staticamente le zone selezionabili
     rebindArea = new Array();  //Funzionalit� della mappa
     $('tr.settore').each (function (){
       // tolgo dal codice colore il #
       color = $(this).attr('data-color').substr(1);
       a = {key: $(this).attr('data-sector'), staticState: false};
       ra = {key: $(this).attr('data-sector'), highlight:true, isSelectable: true,
             toolTip:$(this).attr('data-tooltip')};
       staticArea.push(a);
       rebindArea.push(ra);
     });
     
     $.extend(staticAreaOption, { areas: staticArea } );
     $.extend(rebindOption, { areas: rebindArea , onClick: SHOW.tabellaPrezzi.clickMappa } );
     
     $('#mappaEvento img').mapster(staticAreaOption)
                          .mapster('snapshot')
                          .mapster('rebind', rebindOption, true);
     $('tr.settore').mouseover(function(e) {
       $('#mappaEvento img').mapster('highlight', $(this).attr('data-sector'));
     }).mouseout(function(e) {
       $('#mappaEvento img').mapster('highlight', false);
     }).click(function(e) {
       $('#mappaEvento img').mapster('set', true, $(this).attr('data-sector'));
     });
   },
   clickMappa: function (data){
     $('#tablePrice tr.Prezzi, #tablePrice tr.settore').hide();
     $('#tablePrice tr.sceltaPua').hide();
     $('#tablePrice tr.sceltaPua input[name=pua]').prop('disabled', true).prop('checked',false);
     if (data.selected) {
       var k = data.key.split('-');
       $('h4.selectDescr').show();
       $('#tableWrap').show();
       $('#tablePrice [data-id='+k[0]+']').show();
       $('#tablePriceSubmit').show();
       $('input[type=radio][value='+data.key+']').prop('checked',true);
       namici = parseInt($('#tablePrice tr.Prezzi[data-id='+k[0]+']').attr('data-pua'),10);
       if ($('#tablePrice tr.sceltaPua').length>0 && namici>0) {
         $('#tablePrice tr.sceltaPua').show();
         $('#tablePrice tr.sceltaPua input[name=pua]').prop('disabled', false);
         var amici = (namici>1)? frasi.tabellaPrezzi['friends'] : frasi.tabellaPrezzi['friend'];
         $('#tablePrice tr.sceltaPua #namici').html(namici + ' ' + amici );
       }
       if ($(window).scrollTop() < $('#mappaEvento').offset().top)
         $('html, body').animate({scrollTop: $('#mappaEvento').offset().top}, 2000);
     }
     else {
       $('h4.selectDescr').hide();
       $('#tableWrap').hide();
       $('#tablePriceSubmit').hide();
       $('input[type=radio]').prop('checked', false);
       $('#tablePrice tr.sceltaPua').hide();
       $('#tablePrice tr.sceltaPua input[name=pua]').prop('disabled', true).prop('checked',false);
     }
     return true;
     
   }
};

//-------------------------- SCELTA MANUALE -----------------------------
SHOW.sceltaManuale = {
   // ----------------- MAPPA -----------------------
   impostaEventiMappa: function () {
     //Creo la mappa
     if ($('#mappaEvento.mappahtml img').length == 0) return;
     //Ilumino la mappa al mouseover
     staticArea = new Array();  //Per illuminare staticamente le zone selezionabili
     rebindArea = new Array();  //Funzionalit� della mappa
     $.each(tipoPostoJSON, function (){
       var tp = $(this)[0];
       $.each (tp.settori, function () {
         var s = $(this)[0];
         if (s.posti>0) {
           a =  {key: tp.id+'-'+s.id, staticState: false};
           // gestione settori senza codice
           if (s.id == 'NOCODE')
             sett='';
           else
             sett=s.id;
           ra = {key: tp.id+'-'+s.id, tp:tp.id, sector:s.id, highlight:true, isSelectable: true,
                 toolTip:tp.descrizione+' - '+sett+'<br>' + frasi.tabellaPrezzi['availability'] +': '+s.posti};
           staticArea.push(a);
           rebindArea.push(ra);
         }
         
       });
     });
     
     $.extend(staticAreaOption, { areas: staticArea } );
     $.extend(rebindOption, { areas: rebindArea, onClick: SHOW.sceltaManuale.clickMappa } );
     
     $('#mappaEvento.mappahtml img').mapster(staticAreaOption)
                                    .mapster('snapshot')
                                    .mapster('rebind', rebindOption, true);
     //Click sul pulsante mappa principale
     $('#btnMappa').click ( function () {
       //Mostro la mappa generale
       $('#mappaEvento.mappahtml').show();
       //Nascondo la mappa dei settori
       $('#mappaSettori.mappahtml').hide();
       //Nascondo le istruzioni
       $('.mappahtml.istruzioni').hide();
       //Resetto gli stati selezionati
       $('#mappaSettori.mappahtml td.stato_S').addClass('stato_L').removeClass('stato_S');
       showSeatDescription();
       //Nascondo i bottoni
       $('.mappahtml.buttons').hide();
       $('map[name=map] area').mapster('deselect');
     });
     
     //Faccio partire la rotellina intanto che aspetto Ajax
     $(document).bind("ajaxStart", function(){ $("#loading").show(); }).
                 bind("ajaxStop",  function(){ $("#loading").hide(); });
       
     //Submit del form
     $('#eventPricesMaps form').submit(function (e) {
       var postiSel = $('#mappaSettori.mappahtml td.stato_S');
       if (postiSel.length == 0 || postiSel.length < minBuy ) {
         e.preventDefault();
         if (minBuy == 1)
           alert (frasi.tabellaPrezzi['nTickets']);
         else
           alert (frasi.tabellaPrezzi['nTickets_var'].call( this, minBuy ) );
         return;
       }
       
       //Devo scegliere se voglio aderire al pua
       if (pua > 0 && $('input[name=pua]:checked').length == 0) {
         alert (frasi.tabellaPrezzi['scegliPua']);
         e.preventDefault();
         return false;
       }

       //Controllo il numero dei biglietti
       if (pua > 0 && $('input[name=pua]:checked').val()==1 && postiSel.length > (parseInt(pua,10)+1) ) {
         e.preventDefault();
         alert (frasi.tabellaPrezzi['nPua_var'].call( this, (parseInt(pua,10) + 1) ) );
         return;
       }
       
       postiSel.each (function () {
         desc = tipoPostoName +' '+ frasi.tabellaPrezzi['row'] +' '+ $(this).attr('data-fila') +' '+ frasi.tabellaPrezzi['seat'] +' '+ $(this).attr('data-posto');
         if ($('#mappahtml_seats').val().length == 0) {
           $('#mappahtml_seats').val($(this).attr('data-idposto'));
           $('#mappahtml_descs').val(desc);
           $('#mappahtml_zone').val(tipoPostoCode);
           $('#mappahtml_reds').val(reduction);
         }
         else {
           $('#mappahtml_seats').val($('#mappahtml_seats').val() + ',' + $(this).attr('data-idposto'));
           $('#mappahtml_descs').val($('#mappahtml_descs').val() + '||' + desc);
           $('#mappahtml_zone').val( $('#mappahtml_zone').val()  + ',' + tipoPostoCode);
           $('#mappahtml_reds').val($('#mappahtml_reds').val()  + ',' + reduction);
         }
       });
       

     });
     
   },
   
   
   clickMappa: function (request){
     if (request.selected) {
       $.ajax({
         url : "/extscript/getShowStatoPostiInPianta.php",
         type : "POST",
         data : { sector: request.key, operator: operatorName},
         dataType : 'html',
         cache : false,
         success : function (data, stato) {
           $('#mappaEvento.mappahtml').hide();
           $('#mappaSettori.mappahtml').html(data).css('display', 'inline-block');
           $('.mappahtml.istruzioni').show();
           $('.mappahtml.buttons').show();
           
           $('#mappaSettori.mappahtml td.stato_L').click (bindStatoL);
           $('#mappaSettori.mappahtml td.stato_S').click (bindStatoS);

           if (parseInt(pua) >= 1 ) {
               $('.mappahtml tr.sceltaPua').show();
               var amici = (parseInt(pua) > 1)? frasi.tabellaPrezzi['friends']:frasi.tabellaPrezzi['friend'];
               $('#namici').html(parseInt(pua) + ' ' + amici );
           }
           else
             $('.mappahtml tr.sceltaPua').hide();
         },
         error : function (request, stato, errori) {
           alert(frasi.show['error'].call( this, stato ));
         }
       });
     }
   }
};

function bindStatoS () {
  $(this).addClass('stato_L').removeClass('stato_S');
  $('#mappaSettori.mappahtml td.stato_L').click (bindStatoL);
  showSeatDescription();
}

function bindStatoL () {
  if ($('#mappaSettori.mappahtml .stato_S').length >= maxBuy) return;
  $(this).addClass('stato_S').removeClass('stato_L');
  $('#mappaSettori.mappahtml td.stato_S').click (bindStatoS);
  showSeatDescription();
}

function showSeatDescription () {
  var scelti = '';
  $('#mappaSettori.mappahtml td.stato_S').each (function () {
    scelti = scelti + '<tr><td>'+tipoPostoSector + '</td><td>'+$(this).attr('data-fila')+'</td><td>'+$(this).attr('data-posto')+'</td></tr>';
  });
  $('.mappahtml.postiScelti tbody').html(scelti);
  if (scelti.length == 0) $('.mappahtml.postiScelti').hide();
  else                    $('.mappahtml.postiScelti').show();
}


//-------------------------- SET ANAGRAFICHE -----------------------------
SHOW.SetAnagrafiche = {
    _data:{
      tipoPosto: '',
      prTessera: new Array (),
      squadraDiCasa: '',
      countryHash: '',
      regionHash: '',
      anagrafiche: null
    },

    impostaDati: function (options) {
      _data = $.extend(SHOW.SetAnagrafiche._data, options);
    },
    
    
    /**
     * Funzione per impostare gli eventi sulle anagrafiche
     */
    impostaEventi: function  () {
      if (typeof _data == "undefined" ||
          typeof _data.tipoPosto == "undefined" || _data.tipoPosto.length == 0) return;
      
      //Tessera del tifoso obbligatoria
      if (_data.pua == 1) {
          if (_data.puatype == 2)
              $('fieldset').find('.anagrafica').show();
          else {
              $('fieldset[data-idAnagrafica=0] .tesseraDelTifoso').show();
              $('fieldset').not($('fieldset[data-idAnagrafica=0]')).find('.anagrafica').show();
          }
      }
      else if (_data.tipoPosto == 'P' || _data.tipoPosto == 'O' || (typeof _data.abbonamento != "undefined"  && _data.abbonamento == '1'))
        $('.tesseraDelTifoso').show();
      //Solo anagrafica senza tessera del tifoso
      else if (_data.tipoPosto == 'I') { $('.anagrafica').show(); }
      //Tessera del tifoso facoltativa
      else if ((_data.tipoPosto == 'F'||_data.tipoPosto == 'FM') && _data.prTessera.length == 1 && _data.prTessera[0] == '')
        $('.sceltaTessera').show();
      else if (_data.tipoPosto == 'PM' ||_data.tipoPosto == 'OM' )
        $('.minoreTDT').show();
      
      //Modifiche al campo residenza
      $('select.residenza').change(function () {
        var set = 'fieldset[data-idAnagrafica='+$(this).parents('fieldset').attr('data-idAnagrafica')+']';
        SHOW.SetAnagrafiche.resetSceltaMinore(set);
        SHOW.SetAnagrafiche.resetScelta (set);
        SHOW.SetAnagrafiche.resetTessera (set);
        SHOW.SetAnagrafiche.resetAnagrafica (set);
        SHOW.SetAnagrafiche.mostraPerResidenza(set);
      });

      //Modifiche al campo residenza senza tdt
      //mostro subito la scheda anagrafica
      $('select.residenzaNoTdt').change(function () {
        var set = 'fieldset[data-idAnagrafica='+$(this).parents('fieldset').attr('data-idAnagrafica')+']';
     	  $(set+' .anagrafica').show();
      });
      
      //Scelta tessera
      $('.sceltaTessera input[type=radio]').click(function () {
        if ($(this).is(':visible')) {
          var set = 'fieldset[data-idAnagrafica='+$(this).parents('fieldset').attr('data-idAnagrafica')+']';
          SHOW.SetAnagrafiche.resetTessera (set);
          SHOW.SetAnagrafiche.resetAnagrafica (set);
          SHOW.SetAnagrafiche.mostraPerSceltaTessera(set);
        }
      });

      //Utente minore di X anni validi per la TDT
      $('.minoreTDT input[type=radio]').click(function () {
        if ($(this).is(':visible')) {
          var set = 'fieldset[data-idAnagrafica='+$(this).parents('fieldset').attr('data-idAnagrafica')+']';
          SHOW.SetAnagrafiche.resetTessera (set);
          SHOW.SetAnagrafiche.resetAnagrafica (set);
          SHOW.SetAnagrafiche.mostraPerSceltaMinore(set);
        }
      });
      
      
      //Selezione della squadra
      $('select.squadra').click(function () {
        if ($(this).is(':visible')) {
          var set = 'fieldset[data-idAnagrafica='+$(this).parents('fieldset').attr('data-idAnagrafica')+']';
          if ($(this).val() == '' || $(this).val() == _data.squadraDiCasa )
            SHOW.SetAnagrafiche.resetAnagrafica (set);
          SHOW.SetAnagrafiche.mostraPerSquadra (set);
        }
      });
      
      //per scegliere nazione provincia e comune
      SHOW.chargeData(_data.countryHash, 'select[name^=nazioneNascita]', 'ITA');
      SHOW.chargeData(_data.regionHash,  'select[name^=provinciaNascita]');
      
      $('select[name^=nazioneNascita]').change (function () {
          SHOW.changeEstero($(this), 'select[name^=provinciaNascita]', 'select[name^=comuneNascita]');
        }
      );
      
      $('select[name^=provinciaNascita]').change (function () { SHOW.changeComuni($(this), null, 'select[name^=comuneNascita]'); });
      
      //CHECK SUBMIT
      $('.setAnagrafica #btnAvanti').click(function(e) {
        var ok=true;
        $('fieldset').each(function(){
          if ($(this).find('select.residenza').length > 0 &&
              $(this).find('select.residenza').is(':visible') &&
              $(this).find('select.residenza').val() == ''
              )
            ok=false;
          if ($(this).find('.sceltaTessera input[type=radio]').length > 0 &&
              $(this).find('.sceltaTessera input[type=radio]').is(':visible') &&
              !$(this).find('.sceltaTessera input[type=radio]').is(':checked')
              )
            ok=false;
          
        });
        
        if (!ok) {
          alert (frasi.tabellaPrezzi['checkAnagrafica']);
          e.preventDefault();
          return false;
        }
        return true;
      });

    },
    
    /**
     * Imposta la riduzione scelta durante la scelta manuale
     * Se i dati vengono da una setAnagrafica precedente salto questo passaggio
     */
    impostaDatiRiduzioni: function () {
      if (typeof _data == "undefined" ||
          typeof _data.riduzioni == "undefined" || _data.riduzioni == null ||
          (typeof _data.anagrafiche != "undefined" &&  _data.anagrafiche != null)) return;
      $.each( _data.riduzioni, function (index, value) {
        var set = 'fieldset[data-idAnagrafica='+index+']';
        $(set+' select[name^=riduzione]').val(value);
      });
    },
    
    /**
     * Funzione per reimpostare i dati delle anagrafiche errate
     */
    impostaDatiAnagraficheErrate: function  () {
      if (typeof _data == "undefined" ||
          typeof _data.anagrafiche == "undefined" || _data.anagrafiche == null) return;
      
      //Per ogni anagrafica che ho imposto:
      $.each( _data.anagrafiche, function (index, value) {
        var set = 'fieldset[data-idAnagrafica='+index+']';
        //La riduzione
        $(set+' select[name^=riduzione]').val(value.riduzione);
        //La provincia di residenza
        if ($(set+' select.residenza').length > 0) {
          $(set+' select.residenza').val(value.residenza);
          SHOW.SetAnagrafiche.mostraPerResidenza(set);
        }
        //Se voglio usare o meno la tessera del tifoso
        if ($(set+' .sceltaTessera input[type=radio]').length > 0 && $(set+' .sceltaTessera input[type=radio]').is(':visible')) {
          $(set+' .sceltaTessera input[type=radio][value='+value.sceltaTessera+']').prop('checked',true);
          SHOW.SetAnagrafiche.mostraPerSceltaTessera(set);
        }
        //Se sono troppo piccolo per la tessera del tifoso
        if ($(set+' .minoreTDT input[type=radio]').length > 0 && $(set+' .minoreTDT input[type=radio]').is(':visible')) {
          $(set+' .minoreTDT input[type=radio][value='+value.sceltaTesseraEta+']').prop('checked',true);
          SHOW.SetAnagrafiche.mostraPerSceltaMinore(set);
        }
        
        //La squadra di appartenenza delle tessera del tifoso usata
        if ($(set+' select.squadra').length > 0 && $(set+' select.squadra').is(':visible')) {
          $(set+' select.squadra').val(value.squadra);
          SHOW.SetAnagrafiche.mostraPerSquadra (set);
        }
        //Il numero della tessera
        $(set+' input[name^=tessera]').val(value.tessera);
        
        //I dati anagrafici
        if ($(set+' .anagrafica').is(':visible')) {
          $(set+' input[name^=nome]').val(value.nome);
          $(set+' input[name^=cognome]').val(value.cognome);
          $(set+' input[name^=sesso][value='+value.sesso+']').click();
          dataNascita = value.dataNascita.substr(6,2)+'/'+value.dataNascita.substr(4,2)+'/'+value.dataNascita.substr(0,4);
          if (dataNascita !='//')
            $(set+' input[name^=dataNascita]').val(dataNascita);
          $(set+' select[name^=nazioneNascita]').val(value.nazioneNascita);
          
          if (value.nazioneNascita == 'ITA') {
            $(set+' .soloItalia').show();
            $(set+' select[name^=provinciaNascita]').val(value.provinciaNascita);
            SHOW.changeComuni ($(set+' select[name^=provinciaNascita]'), value.comuneNascita, 'select[name^=comuneNascita]');
          }
          else {
            $(set+' .soloItalia').hide();
          }
        }
        
          
         // Verifico se esiste e se � stato rienpito la tdt per il pua
         puatdt = $('#puatdt');
          if (puatdt.length > 0 && puatdt.val() == '')
              puatdt.addClass('error');

        //Imposto l'eventuale messaggio di errore
        if (typeof value.error != "undefined") {
          if (value.error.indexOf('|') == -1){
            $('#errorBox>div').html(value.error);
            $(set).find('[name^=squadra], [name^=tessera]').addClass('error');
          }
          else {
            if ($(set+' .anagrafica').is(':visible')) {
              //Errori nei campi
              errori = value.error.split('|');
              $.each(errori, function (i,v) {
                if (v != '')
                  $(set).find('[name^='+v+']').parents('.form-group').addClass('has-error has-feedback');
              });
            }
            else {
              if (value.residenza=='')
                $(set).find('[name^=residenza]').addClass('error');
            }
          }
        }
      });
    },
    
    
    /**
     * Funzioni accessorie di reset
     */
    resetAnagrafica: function  (set) {
      set = set + ' .anagrafica';
      $(set+' input[type=text]').val('');
      $(set+' select[name^=nazioneNascita]').val('ITA');
      
      $(set+'.soloItalia').show();
      
      $(set+' select[name^=provinciaNascita]').val('');
      $(set+' select[name^=comuneNascita]').empty();
      
      $(set+' input[name^=sesso][value=M]').prop('checked',true);
      
    },
    
    
    resetTessera:function (set) {
      $(set+' .tesseraDelTifoso select').val('');
      $(set+' .tesseraDelTifoso .squadra option:first').prop('selected', true);
    },
    
    
    resetScelta: function (set) {
      $(set+' .sceltaTessera input').prop('checked',false);
    },
    
    resetSceltaMinore: function (set){
      $(set+' .minoreTDT input').prop('checked',false);
    },
    
    /**
     * Funzioni accessorie di visualizzazione
     */
    mostraPerResidenza: function (set) {
      var val = $(set+' select.residenza').val();
      //Non ho ancora selezionato la residenza
      if (val == '') {
        $(set+' .minoreTDT').hide();
        $(set+' .sceltaTessera').hide();
        $(set+' .tesseraDelTifoso').hide();
        $(set+' .anagrafica').hide();
      }
      //Sono nelle regioni con TDT obbligatoria
      else if ($.inArray(val, _data.prTessera) != -1) {
        $(set+' .sceltaTessera').hide();
        if (_data.tipoPosto == 'FM') {
        	$(set+' .minoreTDT').show();
            $(set+' .tesseraDelTifoso').hide();
            $(set+' .anagrafica').hide();
        }
        else {
       	  $(set+' .minoreTDT').hide();
          $(set+' .tesseraDelTifoso').show();
          $(set+' .anagrafica').hide();
        }
      }
      //Ho selezionato la residenza ma non sono nelle regioni con TDT obbligatoria
      else {
        $(set+' .minoreTDT').hide();
    	  $(set+' .sceltaTessera').show();
        $(set+' .tesseraDelTifoso').hide();
    	  $(set+' .anagrafica').hide();
      }
    },
    
    
    mostraPerSceltaTessera: function (set) {
      var val = $(set+' .sceltaTessera input[type=radio]:checked').val();
      if (val == '1') {
        $(set+' .tesseraDelTifoso').show();
        $(set+' .anagrafica').hide();
      }
      else {
        $(set+' .tesseraDelTifoso').hide();
        $(set+' .anagrafica').show();
      }
    },
    
    mostraPerSceltaMinore: function (set) {
        var val = $(set+' .minoreTDT input[type=radio]:checked').val();
        if (val == '1') {
        	$(set+' .tesseraDelTifoso').hide();
        	$(set+' .anagrafica').show();
        }
        else {
        	$(set+' .tesseraDelTifoso').show();
        	$(set+' .anagrafica').hide();
        }
      },

    
    mostraPerSquadra: function (set) {
      var val = $(set+' select.squadra').val();
      
      if (val == '' || val == _data.squadraDiCasa ) {
        $(set+' .anagrafica').hide();
      }
      else {
        $(set+' .anagrafica').show();
        $(set+' .anagrafica.soloItalia').show();
      }
    }
};


//-------------------------- CAMBIO NOMINATIVO -----------------------------
SHOW.changeUserTicket = {
    _data:{
      countryHash: '',
      regionHash: ''
    },
    impostaDati: function (options) {
      _data = $.extend(SHOW.SetAnagrafiche._data, options);
    },
  impostaSceltaTipo: function () {
    //apro e chiudo il tipo di biglietto
    $('.modeType input[type=radio]').click( function () {
      if ($(this).val() == 1) {
        $(".tdtenable").show();
        $(".ticketenable").hide();
      }
      else {
        $(".tdtenable").hide();
        $(".ticketenable").show();
      }
    });
  },
  impostaEventi: function () {
    //per scegliere nazione provincia e comune
    SHOW.changeAddressData(_data, 'select#NazioneNascita', 'select#ProvinciaNascita', 'select#LuogoNascita');

    //Imposto l'eventuale messaggio di errore
    if (typeof anaError != "undefined") {
      //Errori nei campi
      errori = anaError.split('|');
      $.each(errori, function (i,v) {
        $('#'+v).addClass('error');
      });
    }
  }
    
};


//-------------------------- TESSERA DEL TIFOSO -----------------------------
SHOW.emissioneTdT = {
    _data:{
        countryHash: '',
        regionHash: ''
    },
    impostaDati: function (options) {
        _data = $.extend(SHOW.SetAnagrafiche._data, options);
    },

    impostaEventiSelezioneTdt: function () {
      $('.radio.required input[type=radio]').change(function () {
        $('#submit').val($(this).data('txt'));
      });

        // -- solo OLD
        $('#requiredcmd input[type=radio]').change(function () {
          var txt = $('label[for='+$(this).attr ('id')+']').text();
          $('#submit').val(txt);
        });
        $('#fotoValide').dialog({ autoOpen: false, modal: true, resizable: false, draggable: false, width: '830px' });
        $('#linkFotoValide').click(function () {$('#fotoValide').dialog('open');});
        // -- fine solo OLD
        $('#frmTdtSelection').submit (function (e) {
            if ($('#tdtType').val().length == 0) {
                alert (frasi.show['TDTSelect']);
                return false;
            }
        });
    },
    caricaFoto: function () {
        $('#photoPreview').css({ width: boxW+'px', height: boxH+'px', top: boxY+'px', left: boxX+'px' });
        if (photoName != "") {
            $('<img />').load(function () {
                $('#photoPreview').html($(this));
                showPreview({x: 0, y: 0, w: photoWidth, h: photoHeight}, $('#photoPreview img'));
            }).attr('src', "/extscript/fileUpload.php?download=1&fototesser="+photoName);
            $('#photo').val(photoName);
        }
        $('#fotoValide').dialog({ autoOpen: false, modal: true, resizable: false, draggable: false, width: '830px' });
        $('#linkFotoValide').click(function () {$('#fotoValide').dialog('open');});

        
    },
    impostaSpedizione: function (){
        // ***** SPEDIZIONE ****/
        //Spedizione
        if ($("input[type=hidden][name=tdt_creq_collection_mode]").val() == 'S' ||
          $("input[type=radio][name=tdt_creq_collection_mode]:checked").val() == 'S') {
            $("fieldset#spedizione").show();
            $("fieldset#spedizione").prop('disabled', false);
            $("fieldset#inforitiro").hide();
            $("fieldset#inforitiro").prop('disabled', true);
        }
        //Ritiro
        else if ($("input[type=hidden][name=tdt_creq_collection_mode]").val() == 'R' ||
                 $("input[type=radio][name=tdt_creq_collection_mode]:checked").val() == 'R') {
            $("fieldset#spedizione").hide();
            $("fieldset#spedizione").prop('disabled', true);
            $("fieldset#inforitiro").show();
            $("fieldset#inforitiro").prop('disabled', false);
        }
        //E' attiva la scelta
        else {
          $("fieldset#spedizione").hide();
          $("fieldset#spedizione").prop('disabled', true);
          $("fieldset#inforitiro").hide();
          $("fieldset#inforitiro").prop('disabled', true);
        }
        // aggiorno i campi
        SHOW.changeAddressData(_data, 'select#tdt_creq_ship_nazione', 'select#tdt_creq_ship_prov', 'select#tdt_creq_ship_citta');

        //Se e' attiva la scelta accendo e spengo la sezione giusta sull'change
        $("input[type=radio][name=tdt_creq_collection_mode]").change(function () {
            if (this.value == 'S') {
              $("fieldset#spedizione").show();
              $("fieldset#spedizione").prop('disabled', false);
              $("fieldset#inforitiro").hide();
              $("fieldset#inforitiro").prop('disabled', true);
            }
            else {
              $("fieldset#spedizione").hide();
              $("fieldset#spedizione").prop('disabled', true);
              $("fieldset#inforitiro").show();
              $("fieldset#inforitiro").prop('disabled', false);
            }
            // // riforzo l'aggiornamento dei campi
            SHOW.changeAddressData(_data, 'select#tdt_creq_ship_nazione', 'select#tdt_creq_ship_prov', 'select#tdt_creq_ship_citta');
        });
        
        
        
    },
    impostaEventi: function () {
        //NB: sul sito dell'inter non fanno differenza tra nazioni nascita e di residenza
        //    al momento non lo faccio neanche io
        // ***** DATI ANAGRAFICI ****/
        //per scegliere nazione provincia e comune
        SHOW.changeAddressData(_data, 'select#tdt_creq_tit_nazionen', 'select#tdt_creq_tit_provn', 'select#tdt_creq_tit_comn');
        
        // ***** DATI DOCUMENTO ****/
        //per scegliere  provincia e comune
        //NB: La nazione e' suddivisa solo per italia/estero quindi non la inserisco come le altre
        //SHOW.changeAddressData(_data, 'select#tdt_creq_doc_nazione', 'select#tdt_creq_doc_prov', 'select#tdt_creq_doc_com');
        var docN = 'select#tdt_creq_doc_nazione';
        var docPr = 'select#tdt_creq_doc_prov';
        var docCom = 'select#tdt_creq_doc_com';
        SHOW.chargeData(_data.regionHash, docPr, $(docPr).attr('data-selected'));
        SHOW.changeComuni($(docPr), $(docCom).attr('data-selected'), docCom);
        SHOW.changeEstero($(docN), docPr, docCom, false);
        $(docN).change (function () {
            SHOW.changeEstero($(this), docPr, docCom);
        });
        $(docPr).change (function () { SHOW.changeComuni($(this), null, docCom); });
        
        // ***** DATI TUTORE ****/
        $('#tdt_creq_tit_minore').change(function() {
            if ($(this).val() != '') $("fieldset#tutore").show();
            else                     $("fieldset#tutore").hide();
        });
        //per scegliere nazione provincia e comune
        SHOW.changeAddressData(_data, 'select#tdt_creq_tut_nazionen', 'select#tdt_creq_tut_provn', 'select#tdt_creq_tut_comn');
        
        // ***** RESIDENZA ****/
        //per scegliere nazione provincia e comune
        SHOW.changeAddressData(_data, 'select#tdt_creq_res_nazione', 'select#tdt_creq_res_prov', 'select#tdt_creq_res_citta');
        
        // ***** DOMICILIO ****/
        $('#tdt_creq_same_dom_res').click(function() {
            if ($(this).is(':checked')) $("fieldset#domicilio").hide();
            else                        $("fieldset#domicilio").show();
        });
        //per scegliere nazione provincia e comune
        SHOW.changeAddressData(_data, 'select#tdt_creq_dom_nazione', 'select#tdt_creq_dom_prov', 'select#tdt_creq_dom_citta');
        
    },

    impostaFoto: function () {
        //Imposto la posizione della fototessera
        $('#photoPreview').css({ width: boxW+'px', height: boxH+'px', top: boxY+'px', left: boxX+'px' });
        if (photoName != "") {
            $('<img />').load(function () {
                $('#photoPreview').html($(this));
                showPreview({x: 0, y: 0, w: photoWidth, h: photoHeight}, $('#photoPreview img'));
            }).attr('src', "/extscript/fileUpload.php?download=1&fototesser="+photoName);
            $('#photo').val(photoName);
        }

        $('#fotoValide').dialog({ autoOpen: false, modal: true, resizable: false, draggable: false, width: '830px' });
        $('#linkFotoValide').click(function () {$('#fotoValide').dialog('open');});

        // ***** FILE UPLOAD ****/
        
        $('#file_upload').fileupload({
            url: 'extscript/fileUpload.php',
            dataType: 'json',
            acceptFileTypes: /(\.|\/)(jpe?g|png)$/i,
            maxFileSize: 4000000,
            minWidth: 600, minHeight: 600,
            add: function (e,data) {
                var theFile = data.originalFiles[0];
                var options = $('#file_upload').data('fileupload').options;
                var error = [];
                $('.openCropModal').hide();
                if (theFile['type'].length && !options.acceptFileTypes.test(theFile['type'])) {
                    error.push (frasi.show['invalidimg'].call( this, theFile.name ));
                }
                if(theFile['size'] > options.maxFileSize) {
                    error.push (frasi.show['toobigimg'].call( this, theFile.name ));
                }
                if(error.length > 0) {
                    alert(error.join("\n"));
                    $('#filePreview').hide();
                    $('#filename').text('');
                    $('#photo').val('');
                } else {
                    $('#filePreview').show();
                    $('#filename').text(data.originalFiles[0].name);
                    data.submit();
                }
            },
            progressall: function (e, data) {
                var progress = parseInt(data.loaded / data.total * 100, 10);
                $('.uploadProgress .uploadBar').css('width', progress + '%');
            },
            done: function (e, data) {
                var options = $('#file_upload').data('fileupload').options;
                var error = [];
                $.each(data.result, function (index, file) {
                    //Controllo le dimensioni
                    if (file[0].width < options.minWidth || file[0].height < options.minHeight )
                        error.push (frasi.show['toosmallimg']);
                    if(error.length > 0) {
                        alert(error.join("\n"));
                        $('#filePreview').hide();
                        $('#filename').text('');
                        $('#photo').val('');
                        return;
                    }

                    var newWidth = file[0].width > 818? 818: file[0].width;
                    //Inserisco l'immagine per preview e elaborazione
                    d = new Date(); // uso la data per caricare sempre una immagine nuova
                    $('<img />').load(function () {
                        $('#photoPreview').html($(this));           //Preview
                        $('#fileimage').html($(this).clone());      //Immagine per il crop
                        //Calcolo la posizione del box di crop
                        var left = (file[0].width - photoWidth) / 2;
                        var top = (file[0].height - photoHeight) / 2;
                        $('#fileimage img').Jcrop({allowResize: true,
                                                   allowSelect: false,
                                                   aspectRatio: 1, //Quadrato,
                                                   onChange: function (coords) { showPreview (coords, $('#fileimage img') );},
                                                   boxWidth: newWidth,
                                                   setSelect: [ left, top , (left+photoWidth), (top+photoHeight) ]
                        });
                        //apro la finestra di dialogo
                        if (file[0].width != photoWidth || file[0].height != photoHeight) {
                            $('.openCropModal').css('display', 'inline-block');
                            $('#fileimage').dialog({minWidth: (newWidth + 26) }).dialog('open');
                        }
                    }).attr('src', file[0].url+d.getTime());
                    $('#photo').val(file[0].name);          //Nome della foto
                });
            }
        });

        var cropimgstr = frasi.show['cropimg'];
        $('#fileimage').dialog({
          autoOpen: false, modal: true, resizable: false, draggable: false,
          // alzo la modale a 1200 (il default era 1002, il menu e' a 1025)
          open: function (event, ui) {
        	 $('.ui-dialog').css('z-index',1203);
        	 $('.ui-widget-overlay').css('z-index',1202);
        	},
          buttons: [{
            text: cropimgstr,
            click: function (){$(this).dialog('close');} }]
        });
        
        $('.openCropModal').click(function () {
            $('#fileimage').dialog('open');
        });


    }
    
};


function showPreview(coords, source) {
  $('#x').val(coords.x);
  $('#y').val(coords.y);
  $('#w').val(coords.w);

  var rx = $('#photoPreview').width() / coords.w;
  var ry = $('#photoPreview').height() / coords.h;

  $('#photoPreview img').css({
        width: Math.round(rx * source.width()) + 'px',
        height: Math.round(ry * source.height()) + 'px',
        marginLeft: '-' + Math.round(rx * coords.x) + 'px',
        marginTop: '-' + Math.round(ry * coords.y) + 'px'
  });
}
