
/** PLACEHOLDER SUPPORT */
// This adds 'placeholder' to the items listed in the jQuery .support object.
$(function() {
	jQuery.support.placeholder = false;
	if('placeholder' in document.createElement('input')) jQuery.support.placeholder = true;
});
// This adds placeholder support to browsers that wouldn't otherwise support it.
$(function() {
	if(!jQuery.support.placeholder) {
		var active = document.activeElement;
		$(':text').focus(function () {
			if ($(this).attr('placeholder') != '' && $(this).val() == $(this).attr('placeholder')) {
				$(this).val('').removeClass('hasPlaceholder');
			}
		}).blur(function () {
			if ( !(!$(this).attr('placeholder')) && $(this).attr('placeholder') != '' && ($(this).val() == '' || $(this).val() == $(this).attr('placeholder'))) {
				$(this).val($(this).attr('placeholder')).addClass('hasPlaceholder');
			}
		}).change(function () {
			if ($(this).attr('placeholder') != '' && $(this).val() != $(this).attr('placeholder')) {
				$(this).removeClass('hasPlaceholder');
			}
		});
		$(':text').blur();
		$(active).focus();
		$('form').submit(function (e) {
			$(':text.hasPlaceholder').each(function() { $(this).val('');});
		});
	}
});




/** LINGUE **/

function changeLang(lang_action, trad_urls, lang_code) {
	$('#Lang').attr('action', lang_action);
	if (trad_urls && $('#Lang input[name="Language"]').length == 1)
		$('#Lang input[name="Language"]').val(lang_code);
	$('#Lang').submit();
}


function changeLanguage (lingua) {
	document.Lang.Language.value =lingua;
	document.Lang.submit();
}

/** SIDEBAR **/
function setSideBarPosition () {
	if ( $(window).width() < (72 * 2 + 1030 ) ) {
		$('.sticky').addClass('sticky-inline');
		$('.sticky ul').removeClass('list-unstyled').addClass('list-inline');
		$('.stickyFooter').show();
	}
	else {
		$('.sticky').removeClass('sticky-inline');
		$('.sticky ul').addClass('list-unstyled').removeClass('list-inline');
		$('.stickyFooter').hide();
	}

}

/** COOKIE DISCLAIMER **/

function getCookie(cn) {
	var n = cn + "=";
	var ca = document.cookie.split(';');
	for(var i=0; i<ca.length; i++) {
		var c = ca[i];
		while (c.charAt(0)==' ') c = c.substring(1);
		if (c.indexOf(n) == 0) return c.substring(n.length,c.length);
	}
	return false;
}

function setcookie (cn, date) {
	var o = '';
	var d = new Date();
	date = typeof date !== 'undefined' ? date : false;

	if (date) {
		if (cn.days && cn.days>0)
			d.setTime(d.getTime() + (cn.days * 24 * 60 * 60 * 1000));
		else
			if (cn.hours && cn.hours>0)
				d.setTime(d.getTime() + (cn.hours * 60 * 60 * 1000));
			else // caso default 1 giorno
				d.setTime(d.getTime() + (24 * 60 * 60 * 1000));

		o += "; expires=" + d.toUTCString();
	}
	o += "; path=" + cn.path;
		
	document.cookie = escape(cn.name) + "=" + escape(d.getTime()) + o;
}


/** COUNTDOWN CARRELLO **/

function updateCountDown() {
	if ($('#countdownHeader').length) {
		// se esiste il div che contiene il contatore
		var te = $('#countdownHeader').data('timeend') * 1000;
		var ts = $('#countdownHeader').data('timestart') * 1000;

		if (te==0)
			// se il timeout e' giunto dalla sessione nascondo il contatore (caso svuotamento)
			$('#countdownHeader').hide();
		else {
			// mostro il countdown dell'header
			$('#countdownHeader').show();
		
			if ($(".countdown, #countdown").length)
				// se non sono nel vedi carrello non ho questo secondo countdown
				$('.countdown, #countdown').countdown({
					timeend: te,
					timestart: ts,
					timeDivision: ['M','S'],
					msgGood: '.countdownOK, #countdownOK',
					msgBad: '.countdownKO, #countdownKO'
				});

			$('#countdownHeader').countdown({
				timeend: te,
				timestart: ts,
				timeDivision: ['M','S'],
				callBack: function () {
					if ($('#cart_modal').length) {
						$('#cart_modal').modal('show');
						$('#cart_modal').on('hidden.bs.modal', function (e) {
							window.location.href = '/index.php?nvpg[sell]&cmd=visualizzaCarrello';
						})
					}
				}
			 });
		}
	}
}

//VERIFICA CARRELLO
function checkRegolamentoBasket($alert) {
	if ($('#checkRegolamento').length && !$('#checkRegolamento').prop('checked')) {
		if ($alert) alert(frasi.carrello['checkRegolamento']);
		$('#checkRegolamentoMsg').html(frasi.carrello['required']);
		$('#checkRegolamentoMsg').show();
		return false;
	}
	return true;
}


function getContrast(bg) {
  // la stringa e' formata da 3 numeri separati da ", " e da una numero(eventualmente con un decimale) che e' il canale alfa (che non mi serve)
  var rgb = bg.match(/^rgb(?:a)?\((\d+),\s*(\d+),\s*(\d+)(,\s*(.+))?\)$/);
  // http://www.w3.org/TR/AERT#color-contrast
  var o = Math.round(((parseInt(rgb[1]) * 299) +
                      (parseInt(rgb[2]) * 587) +
                      (parseInt(rgb[3]) * 114)) / 1000);
  return (o > 125) ? 'dark' : 'light';
}


function trackEvent(eName, eParam) {
	//	gtag('event', 'click', {event_action: 'click', event_category: 'Acquista PRICE', event_label: 'TABELLA PREZZI' });
    //  ga('send', 'event', 'Acquista PRICE', 'click', window.location.search);

	if (typeof(gtag) === 'function') 
		gtag('event', eName, eParam);
	else if (typeof(ga) === 'function') 
        ga('send', 'event', eParam.event_category, eName, eParam.event_label);

}

function setOpt (text, value, toSelect) {
  return $('<option>', {text: text, value : value}).prop('selected', toSelect);
}


/** LOAD ANAGRAFICA **/
function loadCountry ($where, preselected) {
  $.each(countryHash, function(value, text) {
    $($where).append( setOpt (text, value, preselected == value));        
  });
}

function loadRegion ($where, preselected) {
  $.each(regionprHash, function(text, data) {
    $($where).append( setOpt (text, data.id, preselected == data.id));        
  });
}


function loadPrForRegion ($where, region, preselected) {
  $.each(regionprHash, function(text, data) {
    if (data.id == region) {
      $.each(data.pr, function(id,sigla) {
        $($where).append( setOpt (eval('regionHash.'+sigla), sigla, preselected == sigla));        
      });    
    }
  });
}


 /** funzioni di escape dei caratteri **/
function padWithLeadingZeros(string) {
    return new Array(5 - string.length).join("0") + string;
}

function unicodeCharEscape(charCode) {
    return "\\u" + padWithLeadingZeros(charCode.toString(16));
}

function unicodeEscape(string) {
    return string.toString().split("")
                 .map(function (char) {
                     var charCode = char.charCodeAt(0);
                     return charCode > 127 ? unicodeCharEscape(charCode) : char;
                 })
                 .join("");
}

/*
$(document).ready(function() {
    $('[name=top-loginForm]').submit(function(e){
        e.preventDefault();
        e.stopPropagation();
        $('#top_loginForm_error').remove();
        $unam = $(this).find('#unam'); 
        if (! /^[a-zA-Z0-9.!#$%&'*+\/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/.test($unam.val()) ) {
            $(this).find('.modal-body').prepend('<p id="top_loginForm_error" class="text-danger">xxxx</p><br>')
            return false;
        }
    });    
});
*/

$(document).ready(function(){
  $("#form_login").validate({
    rules: {
        unam: { required: true, email: true },
        upwd: { required: true }
    },
    messages: {
        unam: {email:  frasi.anagrafica['emailLogin']},
    }

  });
  $("form[name=top-loginForm]").validate({
    rules: {
        unam: { required: true, email: true },
        upwd: { required: true }
    },
    messages: {
      unam: {email:  frasi.anagrafica['emailLogin']},
    }
  });
});

$(document).ready(function() {
	/** COOKIE BAR **/
	var cd = {
		'name': 'cookieAgreed',
		'value':1,
		'days':730, /* 2 anni */
		'path':'/'
	};

	var c = getCookie(cd.name);
	$('#cookie-bar .closeBtn').click( function(event) {
		// nascondo il popup
		$('#cookie-bar').hide();
		// quando chiudo il popup setto il cookie
		setcookie(cd);
	});
	if (c == false) {
		$('#cookie-bar').show();
		// Solo il click sulla x del popup deve fare la chiusura del popup
		// handler chiusura popup
		// quando faccio un click su link o su un input setto il cookie
		$("a, :input").click( function(event) {
			setcookie(cd);
		});
	}
	else {
		var d = new Date();
		$('#cookie-bar').hide();
		if (c < d.getTime())
			setcookie(cd, true);
	}
	
	/** PRYVACY BAR **/
	var pd = {
		'name': 'privacy',
		'value':1,
		'days':0, /* alla chiusura del browser */
		'path':'/'
	};

	var p = getCookie(pd.name);
	$('#privacy-bar .closeBtn').click( function(event) {
		// nascondo il popup
		$('#privacy-bar').hide();
		// quando chiudo il popup setto il cookie
		setcookie(pd);
	});
	if (p == false) {
		$('#privacy-bar').show();
		// Solo il click sulla x del popup deve fare la chiusura del popup
		// handler chiusura popup
		// quando faccio un click su link o su un input setto il cookie
		//$("a, :input").click( function(event) {
		//	setcookie(pd);
		//});
	}
	

	
	
	/** FIX FOR OLD */
	$('.version-fix').find('.hidden').removeClass('hidden').hide();
	$('.eventAction .button.gradientButton').removeClass('button gradientButton').addClass('btn btn-primary btn-sm btn-font text-uppercase');
	$('section#promotionBox div#promotionDetails.infoPromotion div').removeClass('bad').removeClass('msg');
	
	
	/** LISTE DI EVENTI */
	if(jQuery().perfectScrollbar) {
		$('.scrollbar').perfectScrollbar({suppressScrollY: true});
	 }

	/** MENU
	 *  Sia il menu desktop che il menu mobile si aprono e si chiudono
	 **/
	$('#menu-cat-bars, #menu-cat-bars-mobile').on("click",function(e){
		$('#menu-cat>ul>li').removeClass('open').parent().toggle();
		e.stopPropagation();
	});

	/** MENU ALTERNATIVO
	 * Quando ho bisogno di comportamenti diversi tra il menu mobile ed il menu desktop
	 * con menu desktop fisso e menu mobile che si apre e si chiude
	 **/
	$('#menu-cat-bars-mobile').on("click",function(e){
		$('.hidden-md #menu-cat-alt>ul>li').removeClass('open').parent().toggle();
		e.stopPropagation();
	});

	
	/** MENU UTENTE **/
	$('#menu-user-bars').on("click",function(e){
		$('#menu-user-mobile>ul>li').removeClass('open').parent().toggle();
		e.stopPropagation();
	});
	
	/** SIDEBAR **/
	
	setSideBarPosition();
	
	$(window).resize(function(){
		setSideBarPosition();
	});
	

	/** BACK TO TOP **/
	if ( ($(window).height() + 100) < $(document).height() ) {
		$('#back-to-top').removeClass('hidden').affix({
			// how far to scroll down before link "slides" into view
			offset: {top:100}
		});
	}
	//cambio colore quando e' dentro il footer
	$(window).scroll(function() {
		//il back-to-top non e' presente in homepage, quindi devo testarlo
		if ($('#back-to-top').length) {
			if ($('#footer').offset().top < ($('#back-to-top').offset().top + 28))
				$('#back-to-top .fa-stack').addClass('fa-inverse');
			else
				$('#back-to-top .fa-stack').removeClass('fa-inverse');
		}
	});
	
	$('#back-to-top a').click(function(e){
		// cosi' evito di andare prima su all'ancora poi ritornare giu e scrollo lentamente verso l'ancora
		e.preventDefault();
		$('html,body').animate({scrollTop:0},'slow');
		e.stopPropagation();
	});

	/** TOOLTIP GRAFICI **/
	$('[data-toggle="tooltip"]').tooltip();

	/** SELL **/
	$('#captcha_reload').click (function () {
		$('#captcha_img').attr('src','/dynimage/createCaptcha.php?redo_code=1&rdn=' + Math.random());
		$('#transcription').focus();
	})
	/** SELL OLD **/
	 // apro e chiudo l'alert per la scelta manuale disabilitata
	 $('ul.eventActionMenu li.disabledTab').mouseenter(function(){
		$('div#noManual').show();
	}).mouseleave(function(){
		$('div#noManual').hide();
	});

	/** CAROUSEL **/
	if ($('#carousel').length > 0) {

		//Carousel size
		var mbSetWidth = function ($c) {
			$c.options.width = $(window).width();
			var L = 680 / $c.options.width;
			if (L>0.9) L = 0.9;
			$c.options.panelWidth = L;
		};
		//Imposto l'autoLoop che non viene fatto da solo dal plugin ma pazienza
		var mbTimer,
		mbLoop = function (mb) {
			mb.goForward();
			mbTimer = setTimeout(function(){ mbLoop(mb); }, 5000);
		};
		
		var initOp = function () {
			$('#carousel').show();
			var $c = $('#carousel').getMovingBoxes();
			mbSetWidth($c)
			$c.update(false);
			mbLoop ($c);
		};
		
		
		
		
		//Start operation
		$('#carousel').movingBoxes({
			reducedSize  : 1,
			wrap         : true,
			initialized  : initOp
		});
		
		// la slide attiva deve occupare al massimo il 90% dello spazio
		// e deve essere al massimo larga 680px.
		// Quindi se lo spazio a disposizione è piccolo imposto la dimensione delle slide al 90%
		var timer;
		$(window).resize(function(){
			clearTimeout(timer);
			var $c = $('#carousel').data('movingBoxes');
			mbSetWidth($c);
			// prevent updating continuously, aka throttle resize
			timer = setTimeout(function(){
				$c.update(false);
			}, 100);
		});
	}
	
	var rgb = ($('#footer-logo').css('background-color') == 'rgba(0, 0, 0, 0)' ||  
               $('#footer-logo').css('background-color') == 'transparent')? $('#footer').css('background-color') : $('#footer-logo').css('background-color');
	if ($('#footer-logo').length && getContrast(rgb)  == 'dark' ) {
		$('#footer-logo #vivaimg').attr('src', hostServerImage + 'wms_images/logos/logoTopbar_vivaticket_B.png');
	}

	rgb = $('#footer-nav').css('background-color') == 'rgba(0, 0, 0, 0)' ||
	      $('#footer-nav').css('background-color') == 'transparent'? $('#footer').css('background-color') : $('#footer-nav').css('background-color');
	if ($('#footer-nav').length && getContrast(rgb)  == 'dark' ) {
		$('#logonst').attr('src', hostServerImage + 'wms_images/logonosecondaryticket/NOST_TN_logo2017_200px.png');
	}
	
});
