//jQuery.validator.setDefaults({ debug: true }); //VIVATK100006547389
var rimborso_no_num_pattern   =  /^[^\d\x00-\x1F\!\"\#\$\%\&\(\)\*\\\:<=>?\[\]\^`{\|}~\r\n\f\@]*$/;
var rimborso_num_pattern      = /^[\w]+$/;

jQuery.validator.addMethod("IBANChk", function(value, element) {
	  return this.optional(element) || IBANChk(value);
	}, "Please check your input.");

$(document).ready(function(){
	 $("#step1.rimborso").validate({
		 rules: {
			 trCode: {required:true, exactlength: 18}
		 },
		 messages: {
			 trCode: {exactlength:frasi.rimborso['trCode']}
		 }
	 });
	 
	 $("#step2.rimborso").validate({
		 rules: {
			 trCustRef: {required:true}
		 },
		 errorPlacement: function(error, element) {
			 error.appendTo( element.parent("td").next("td") );
	     }
	 });
	 
	 $('#step3.rimborso .straniero').hide();
	 $("#step3.rimborso #naz_it").click(function (){$('.straniero').hide();});
	 $("#step3.rimborso #naz_es").click(function (){$('.straniero').show();});

	 $("#step3.rimborso").validate({
		 rules: {
			 intestatario: {required: true, rangelength: [2, 25], regex: rimborso_no_num_pattern},
			 email: {email: true},
			 indirizzo: {required: {depends: function() {return $('#naz_es').is(':checked');}}},
			 cap:       {required: {depends: function() {return $('#naz_es').is(':checked');}}, minlength: 4,  regex: rimborso_num_pattern},
			 nazione:   {required: {depends: function() {return $('#naz_es').is(':checked');}}, minlength: 2},
			 iban:      {required: true, IBANChk: true},
			 swift:     {required: {depends: function() {return $('#naz_es').is(':checked');}}, bic:true}
		 },
		 messages: {
			 intestatario: {regex: frasi.rimborso['intestatario']},
		     indirizzo:    {regex: frasi.rimborso['address']},
		     cap:          {regex: frasi.rimborso['CAP']},
		     iban:         {IBANChk: frasi.rimborso['IBAN']},
		     swift:        {bic: frasi.rimborso['SWIFT']}
		 }
	 });
});



function IBANChk(IBAN) {
  b = IBAN.replace(/ /g,"");

  if (b.length < 5) return false;

  s = b.substring(4) + b.substring(0, 4);
  for (i = 0, r = 0; i < s.length; i++ ) {
    c = s.charCodeAt(i);
    if (48 <= c && c <= 57) {
      if (i == s.length-4 || i == s.length-3) return false;
      k = c - 48;
    } else if (65 <= c && c <= 90) {
      if (i == s.length-2 || i == s.length-1) return false;
      k = c - 55;
    } else return false;
    if (k > 9) r = (100 * r + k) % 97;
    else       r = (10 * r + k) % 97;
  }
  if (r != 1) return false;
  return true;
}

